searchNodes=[{"ref":"ServerSentEvent.html","title":"ServerSentEvent","type":"module","doc":"Push updates to Web clients over HTTP or using dedicated server-push protocols. Messages are sent in the following form, with the text/event-stream MIME type: data: This is the first message. data: This is the second message, it data: has two lines. event: custom data: This message has event type &#39;custom&#39;. A living standard is available from WHATWG. The contents of a server-sent-event are: typeThe type of an event linesThe data contents of the event split by line idValue to send in last-event-id header when reconnecting retryTime to wait before retrying connection in milliseconds commentsAny lines from original block that were marked as comments"},{"ref":"ServerSentEvent.html#empty?/1","title":"ServerSentEvent.empty?/1","type":"function","doc":"Does the event have any data lines. An event without any data lines will not trigger any browser events."},{"ref":"ServerSentEvent.html#mime_type/0","title":"ServerSentEvent.mime_type/0","type":"function","doc":"This event stream format&#39;s MIME type is text/event-stream."},{"ref":"ServerSentEvent.html#new/2","title":"ServerSentEvent.new/2","type":"function","doc":"Create a ServerSentEvent struct. Examples iex&gt; SSE.new(&quot;my data&quot;) ...&gt; |&gt; Map.get(:lines) [&quot;my data&quot;] iex&gt; SSE.new(&quot;some\\r\\nlines&quot;) ...&gt; |&gt; Map.get(:lines) [&quot;some&quot;, &quot;lines&quot;] iex&gt; SSE.new(&quot;some\\nlines&quot;) ...&gt; |&gt; Map.get(:lines) [&quot;some&quot;, &quot;lines&quot;] iex&gt; SSE.new(&quot;my data&quot;, id: &quot;45&quot;) ...&gt; |&gt; Map.get(:id) &quot;45&quot; iex&gt; SSE.new(&quot;my data&quot;, retry: 45) ...&gt; |&gt; Map.get(:retry) 45 iex&gt; SSE.new(&quot;my data&quot;, type: &quot;update&quot;) ...&gt; |&gt; Map.get(:type) &quot;update&quot;"},{"ref":"ServerSentEvent.html#parse/1","title":"ServerSentEvent.parse/1","type":"function","doc":"Parse the next event from text stream, if present. Examples In these examples this module has been aliased to SSE. iex&gt; SSE.parse(&quot;data: This is the first message\\n\\n&quot;) {:ok, {%SSE{lines: [&quot;This is the first message&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;data:First whitespace character is optional\\n\\n&quot;) {:ok, {%SSE{lines: [&quot;First whitespace character is optional&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;data: This message\\ndata: has two lines.\\n\\n&quot;) {:ok, {%SSE{lines: [&quot;This message&quot;, &quot;has two lines.&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;data: This is the first message\\n\\nrest&quot;) {:ok, {%SSE{lines: [&quot;This is the first message&quot;]}, &quot;rest&quot;}} iex&gt; SSE.parse(&quot;data: This message is not complete&quot;) {:ok, {nil, &quot;data: This message is not complete&quot;}} iex&gt; SSE.parse(&quot;This line is invalid\\nit doesn&#39;t contain a colon\\n&quot;) {:error, {:malformed_line, &quot;This line is invalid&quot;}} iex&gt; SSE.parse(&quot;event: custom\\ndata: This message is type custom\\n\\n&quot;) {:ok, {%SSE{type: &quot;custom&quot;, lines: [&quot;This message is type custom&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;id: 100\\ndata: This message has an id\\n\\n&quot;) {:ok, {%SSE{id: &quot;100&quot;, lines: [&quot;This message has an id&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;retry: 5000\\ndata: This message retries after 5s.\\n\\n&quot;) {:ok, {%SSE{retry: 5000, lines: [&quot;This message retries after 5s.&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;retry: five thousand\\ndata: retry value is not a valid integer\\n\\n&quot;) {:error, {:invalid_retry_value, &quot;five thousand&quot;}} iex&gt; SSE.parse(&quot;: This is a comment\\n\\n&quot;) {:ok, {%SSE{comments: [&quot;This is a comment&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;data: data can have more :&#39;s in it&#39;\\n\\n&quot;) {:ok, {%SSE{lines: [&quot;data can have more :&#39;s in it&#39;&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;DATA: field names are case-sensitive\\n\\n&quot;) {:error, {:invalid_field_name, &quot;DATA&quot;}} iex&gt; SSE.parse(&quot;unknown: what is this field?\\n\\n&quot;) {:error, {:invalid_field_name, &quot;unknown&quot;}} # It is possible for an event stream using `CRLF` to be split mid line delimiter. # In this case the parser needs to clear the leading newline character. iex&gt; SSE.parse(&quot;data: This is the first message\\r\\n\\r&quot;) {:ok, {%SSE{lines: [&quot;This is the first message&quot;]}, &quot;&quot;}} iex&gt; SSE.parse(&quot;\\ndata: This is the second message\\r\\n\\r\\n&quot;) {:ok, {%SSE{lines: [&quot;This is the second message&quot;]}, &quot;&quot;}}"},{"ref":"ServerSentEvent.html#parse_all/1","title":"ServerSentEvent.parse_all/1","type":"function","doc":"Parse all events from text stream. Examples In these examples this module has been aliased to SSE. iex&gt; SSE.parse_all(&quot;data: First message\\n\\ndata: Second\\ndata: message\\n\\nrest&quot;) {:ok, { [ %SSE{lines: [&quot;First message&quot;]}, %SSE{lines: [&quot;Second&quot;, &quot;message&quot;]} ], &quot;rest&quot; } } iex&gt; SSE.parse_all(&quot;data: This is the first message\\n\\n&quot;) {:ok, {[%SSE{lines: [&quot;This is the first message&quot;]}], &quot;&quot;}} iex&gt; SSE.parse_all(&quot;data: This is the first message\\n\\nrest&quot;) {:ok, {[%SSE{lines: [&quot;This is the first message&quot;]}], &quot;rest&quot;}} iex&gt; SSE.parse_all(&quot;data: This message is not complete&quot;) {:ok, {[], &quot;data: This message is not complete&quot;}} iex&gt; SSE.parse_all(&quot;This line is invalid\\nit doesn&#39;t contain a colon\\n&quot;) {:error, {:malformed_line, &quot;This line is invalid&quot;}} iex&gt; SSE.parse_all(&quot;data: This is the first message\\n\\nThis line is invalid\\n&quot;) {:error, {:malformed_line, &quot;This line is invalid&quot;}} iex&gt; SSE.parse_all(&quot;data: This is the first message\\n\\nThis line is yet to terminate&quot;) {:ok, {[%SSE{lines: [&quot;This is the first message&quot;]}], &quot;This line is yet to terminate&quot;}}"},{"ref":"ServerSentEvent.html#serialize/1","title":"ServerSentEvent.serialize/1","type":"function","doc":"Format an event to be sent as part of a stream serialize accepts the same arguments as new to create and serialize in one step. NOTE: Each data/comment line must be without new line charachters. Examples In these examples this module has been aliased to SSE. iex&gt; SSE.serialize(&quot;my data&quot;, type: &quot;update&quot;) &quot;event: update\\ndata: my data\\n\\n&quot; iex&gt; %SSE{type: &quot;greeting&quot;, lines: [&quot;Hi,&quot;, &quot;there&quot;], comments: [&quot;comment&quot;]} ...&gt; |&gt; SSE.serialize() &quot;event: greeting\\n: comment\\ndata: Hi,\\ndata: there\\n\\n&quot; iex&gt; %SSE{lines: [&quot;message with id&quot;], id: &quot;some-id&quot;} ...&gt; |&gt; SSE.serialize() &quot;data: message with id\\nid: some-id\\n\\n&quot; iex&gt; %SSE{lines: [&quot;message setting retry to 10s&quot;], retry: 10_000} ...&gt; |&gt; SSE.serialize() &quot;data: message setting retry to 10s\\nretry: 10000\\n\\n&quot;"},{"ref":"ServerSentEvent.html#serialize/2","title":"ServerSentEvent.serialize/2","type":"function","doc":""},{"ref":"ServerSentEvent.html#t:t/0","title":"ServerSentEvent.t/0","type":"type","doc":""},{"ref":"ServerSentEvent.Client.html","title":"ServerSentEvent.Client","type":"behaviour","doc":"Client that pulls and processes events from a server sent event stream. This client can be used to manage reconnecting a dropped connection. A specific client needs to implement the callbacks from this behaviour. Note there is no use macro in this module, therefore all callbacks must be implemented. Example defmodule AutoConnect do @behaviour ServerSentEvent.Client # Start connecting to the endpoint as soon as client is started. def init(state) do {:connect, request(state), state} end # The client has successfully connected, or reconnected, to the event stream. def handle_connect(_response, state) do {:noreply, state} end # Retry connecting to endpoint 1 second after a failure to connect. def handle_connect_failure(reason, state) do Process.sleep(1_000) {:connect, request(state), state} end # Immediatly try to reconnect when the connection is lost. def handle_disconnect(_, state) do {:connect, request(state), state} end # Update the running state of the client with the id of each event as it arrives. # This event id is used for reconnection. def handle_event(event, state) do IO.puts(&quot;I just got a new event: \#{inspect(event)}&quot;) %{state | last_event_id: event.id} end # When stop message is received this process will exit with reason :normal. def handle_info(:stop, state) do {:stop, :normal, state} end # Not a callback but helpful pattern for creating requests in several callbacks defp request({url: url}) do Raxx.request(:GET, url) |&gt; Raxx.set_header(&quot;accept&quot;, &quot;text/event-stream&quot;) |&gt; Raxx.set_header(&quot;last-event-id&quot;, state.last_event_id) end end # Starting the client {:ok, pid} = AutoConnect.start_link(%{url: &quot;http://www.example.com/events&quot;, last_event_id: &quot;0&quot;}) The client can also be added to a supervision tree children = [ {AutoConnect, %{url: &quot;http://www.example.com/events&quot;, last_event_id: &quot;0&quot;}} ]"},{"ref":"ServerSentEvent.Client.html#child_spec/1","title":"ServerSentEvent.Client.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ServerSentEvent.Client.html#c:handle_connect/2","title":"ServerSentEvent.Client.handle_connect/2","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#c:handle_connect_failure/2","title":"ServerSentEvent.Client.handle_connect_failure/2","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#c:handle_disconnect/2","title":"ServerSentEvent.Client.handle_disconnect/2","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#c:handle_event/2","title":"ServerSentEvent.Client.handle_event/2","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#c:handle_info/2","title":"ServerSentEvent.Client.handle_info/2","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#handle_packet/2","title":"ServerSentEvent.Client.handle_packet/2","type":"function","doc":""},{"ref":"ServerSentEvent.Client.html#c:init/1","title":"ServerSentEvent.Client.init/1","type":"callback","doc":""},{"ref":"ServerSentEvent.Client.html#start/3","title":"ServerSentEvent.Client.start/3","type":"function","doc":""},{"ref":"ServerSentEvent.Client.html#start_link/3","title":"ServerSentEvent.Client.start_link/3","type":"function","doc":""},{"ref":"ServerSentEvent.Client.html#t:request/0","title":"ServerSentEvent.Client.request/0","type":"type","doc":""},{"ref":"ServerSentEvent.Client.html#t:response/0","title":"ServerSentEvent.Client.response/0","type":"type","doc":""},{"ref":"ServerSentEvent.Client.html#t:return/0","title":"ServerSentEvent.Client.return/0","type":"type","doc":"Return value from any callback, except handle_event/2 This value instructs the client process with what it should do next :connect start the process of connection to an event source, using the request given. :noreply do nothing, and wait for next message. :stop stop the client and exit with reason."},{"ref":"ServerSentEvent.Client.html#t:state/0","title":"ServerSentEvent.Client.state/0","type":"type","doc":"State of the client process. The initial value of this state given as the second argument to start_link/3"},{"ref":"readme.html","title":"ServerSentEvent","type":"extras","doc":"ServerSentEvent Push updates to web clients over HTTP, using dedicated server-push protocol. Install from Hex Documentation available on hexdoc Server Sent Event Standard https://html.spec.whatwg.org/#server-sent-events"},{"ref":"readme.html#usage","title":"ServerSentEvent - Usage","type":"extras","doc":"Parsing and Serializing iex(1)&gt; event = ServerSentEvent.new(&quot;my data&quot;) %ServerSentEvent{ comments: [], id: nil, lines: [&quot;my data&quot;], retry: nil, type: nil } iex(2)&gt; binary = ServerSentEvent.serialize(event) &quot;data: my data\\n\\n&quot; iex(3)&gt; {:ok, {^event, &quot;&quot;}} = ServerSentEvent.parse(binary) {:ok, {%ServerSentEvent{ comments: [], id: nil, lines: [&quot;my data&quot;], retry: nil, type: nil }, &quot;&quot;}} Client This project also includes a general purpose client. See documentation for ServerSentEvent.Client for more information."},{"ref":"readme.html#testing","title":"ServerSentEvent - Testing","type":"extras","doc":"git clone git@github.com:CrowdHailer/server_sent_event.ex.git cd server_sent_event.ex mix deps.get mix test mix dialyzer"},{"ref":"readme.html#benchmarks","title":"ServerSentEvent - Benchmarks","type":"extras","doc":"Some microbenchmarks have been written to inform some implementation decisions To run them, run mix run bench/*"}]